#include <misc.h>
#include <params.h>
#include <preproc.h>

module camiodata
!----------------------------------------------------------------------- 
!
! Purpose: I/O related objects in CAM
!
! Author: Woo-Sun Yang
!
!----------------------------------------------------------------------- 
   implicit none

!  Number of I/O staging processes for ZioLib

   integer, save :: niopes_nfrd = 1     ! netCDF read
   integer, save :: niopes_nfwr = 1     ! netCDF write
   integer, save :: niopes_nfgr = 1     ! netCDF write of partial fields

!  Communicators for ZioLib's I/O staging processes

   integer, save :: iocomm_nfrd         ! netCDF read
   integer, save :: iocomm_nfwr         ! netCDF write
   integer, save :: iocomm_seq          ! restart I/O (sequential-access I/O)

!  Logical unit numbers for sequential-access files

   integer, save :: znsds                ! restart dataset unit
   integer, save :: znrg                 ! master regeneration dataset unit
   integer, save :: znrg2                ! abs/ems regeneration dataset units
   integer, save :: zluhrest             ! history restart unit

!  ZioLib's file descriptors for sequential-access files

   integer, save :: fd_rg               ! for nrg
   integer, save :: fd_rg2              ! for nrg2
   integer, save :: fd_hrest            ! for luhrest

!  ZioLib's file descriptors for netCDF files
   integer, save :: zncid_ini            ! initial dataset
   integer, save :: zncid_oz             ! ozone dataset
   integer, save :: zncid_trc            ! greenhouse gas tracer dataset
   integer, save :: zncid_sst            ! sst dataset

!  ZioLib's distributed array descriptors for dynamics decompositions

   integer, save :: distxy
   integer, save :: distxyz,   distxzy
   integer, save :: distxyzp,  distxzyp
   integer, save :: distusxyz, distusxzy, distusxzym, distus_d
   integer, save :: distvsxyz, distvsxzy,             distvs_d

   integer, save :: distxy_d
   integer, save :: distxdzy_d, distxzy_d
   integer, save :: distxzye_d

   integer, save :: distxyz_d
   integer, save :: distxyez_d
   integer, save :: distxdzpye_d

   integer, save :: distqfcst
   integer, save :: distq3

!  ZioLib's distributed array descriptors for physics decompositions
!  (local fields must be prepared in xyz-blocks)

   integer, save :: distxy_p
   integer, save :: distxyz_p,  distxzy_p
   integer, save :: distxyzp_p, distxzyp_p
   integer, save :: distxyt_p
   integer, save :: distxzyt_p

   integer, save :: distxzy4_p
   integer, save :: distxzzy_p
   integer, save :: distxyzm_p, distxzmy_p

   integer, save :: distqpert

end module camiodata
