#include <misc.h>
#include <params.h>
#include <preproc.h>
   subroutine distarray_dyn ()
!----------------------------------------------------------------------- 
! 
! Purpose: Define distributed array objects for dynamics variables
! 
! Author: Woo-Sun Yang
! 
!-----------------------------------------------------------------------
      use camiodata
!TS      use zio,           only: zio_new_distarray
#ifdef SPMD
      use mpishorthand, only: mpiordf,mpir8
#endif
#if (defined STAGGERED)
      use pmgrid,        only: beglat, endlat, plat, plon, plev, plevp, &
                               splon, beglev, endlev, endlevp&
	                      ,beglonxy,endlonxy,iam,myidxy_x,myidxy_y,myid_z,nprxy_y,nprxy_x
			       
      use dynamics_vars, only: ng_d, ng_s
#else
      use pmgrid,        only: beglat, endlat, plat, plon, plev, plevp
#endif
      use constituents,  only: pcnst, pnats, ppcnst

      implicit none
#if (!defined STAGGERED)
      integer :: beglev, endlev, endlevp
#endif
      integer :: loff(4), lsize(4), ghstl(4), ghstr(4)
      integer :: ret
      integer :: numlev,numlon

#if (!defined STAGGERED)
      beglev  = 1
      endlev  = plev
      endlevp = plevp
#else
!TS     print*,'beglonxy',iam,myidxy_x,myidxy_y,beglonxy,endlonxy,beglat,endlat
     numlev=endlev-beglev+1
     numlon=plon
     loff=0
     lsize=0
     ghstl=0
!...  (plon,plev,plat-1) distributed: US history variable

      if (beglat == 1) then    ! skip lat=1, treating it as a ghost layer
         lsize(1:3) = (/ numlon, endlat-beglat+1, numlev/)
         loff(1:3) = (/ numlon, endlat-beglat, numlev/)
         ghstl(1:3) = (/ 0, 1, 0 /)
      else                     ! shift global lat index down by 1
         lsize(1:3) = (/ numlon, endlat-beglat+1, numlev /)
	 loff(1:3)  = lsize(1:3)
         ghstl(1:3) = (/ 0, 0, 0 /)
      end if
!TS      print*,beglat,endlat,beglev,endlev
!TS      print*,'size',lsize(1:3),loff(1:3),ghstl(1:3)
      call mpi_type_create_subarray(3,lsize(1:3),loff(1:3),ghstl(1:3),&
	mpiordf,mpir8,distusxyz,ret)
      call mpi_type_commit(distusxyz,ret)
!TS      print*,'mpi_type_create',distusxyz
#endif
   end subroutine distarray_dyn